Index: sandbox/expresso-solr/expressoMail1_2/inc/class.imap_functions.inc.php
===================================================================
--- sandbox/expresso-solr/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 7552)
+++ sandbox/expresso-solr/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 8056)
@@ -4974,5 +5282,127 @@
 			$search = $params['search'];
 		}
+		
+		if(isset($_SESSION['phpgw_info']['expresso']['expressoMail']['expressoMail_enable_solr']) && $_SESSION['phpgw_info']['expresso']['expressoMail']['expressoMail_enable_solr'] === 'true')
+		{
+			$useSolr = true;
+		}
+		
+		if($useSolr == true)
+		{
+			foreach ($params['folder'] as $folder) 
+			{
+				
+				$imap = $this->open_mbox( $folder ) ;
 	
+				//$msgIds = imap_sort( $imap , SORTDATE , 1 , SE_UID , $search ,'UTF-8');
+							
+				/*include("solrclient/init.php");*/
+			
+				$solrConfig = array(
+						'adapteroptions' => array(
+						'host' => '127.0.0.1',
+					        'port' => 8983,
+		        			'path' => '/solr/',
+					)
+				);
+				// create a client instance
+				$solariumClient = new Solarium_Client($solrConfig);
+				$solrQuery = $solariumClient->createSelect();
+				$usernameAux = $this->username;
+				$solrSearch = $params['search'];
+
+				$solrFolder = $folder;
+				if(count(split("/", $folder) ) > 1 )
+				{
+					$folderArrayAux = split("/", $folder);
+					$solrFolder = $folderArrayAux[1];
+				}
+				
+				$solrQuery->setQuery("(content:\"$solrSearch\" OR subject:\"$solrSearch\" OR from:\"$solrSearch:\") AND user:$usernameAux AND folder:$solrFolder" );
+				$solrQuery->setFields(array('id', 'msg_no'));
+				$solrQuery->addSort("sent_date", "desc");
+				// override the default row limit of 10 by setting rows to 50
+				$solrQuery->setRows(50);
+				// this executes the query and returns the result
+				$resultset = $solariumClient->select($solrQuery);
+				
+				$count += count($resultset);  
+				
+				foreach ($resultset as $document)
+				{	
+					$v = $document['msg_no'];
+					
+					$msg = imap_headerinfo ( $imap,  imap_msgno($imap, $v) );
+					if ($msg->message_id != $document['id'])
+					{
+						continue;
+					}
+	
+					if(isset($msg->from[0]))
+					{
+						$from = self::formatMailObject( $msg->from[0] );
+						$return['msgs'][$i]['from'] 	= mb_convert_encoding($from['name'] ? $from['name'] : $from['email'], 'UTF-8');
+					}
+					else
+						$return['msgs'][$i]['from'] 	= ''; 
+					
+					$return['msgs'][$i]['subject'] = ' ';
+				
+					$subject = imap_mime_header_decode($msg->subject);
+					foreach ($subject as $tmp)
+						$return['msgs'][$i]['subject'] .= mb_convert_encoding($tmp->text, 'UTF-8', 'UTF-8 , ISO-8859-1');
+				
+					$filter = array('AND', array('=', 'folderName', $folder), array('=','messageNumber', $v));
+					$followupflagged = Controller::find(
+						array('concept' => 'followupflagged' , 'folder' => $folder ),
+						false, 
+						array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+					);
+
+					if(isset($followupflagged[0]['followupflagId']))
+					{
+						$followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));     
+						$followupflagged[0]['followupflag'] = $followupflag;
+						$return['msgs'][$i]['followupflagged'] = $followupflagged[0];
+
+					}	
+					$labeleds = Controller::find(
+						array('concept' => 'labeled'),
+						false, 
+						array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+					);
+					if(is_array($labeleds))
+						foreach ($labeleds as $e){
+							$labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));     
+							$return['msgs'][$i]['labels'][$e['labelId']] = $labels;
+						}
+					$mimeBody = imap_body( $this->mbox, $v  , FT_UID|FT_PEEK  );	
+					$return['msgs'][$i]['flag'] = ' ';
+					$return['msgs'][$i]['flag'] .= $msg->Unseen ? $msg->Unseen : '';
+					$return['msgs'][$i]['flag'] .= $msg->Recent ? $msg->Recent : '';	
+					$return['msgs'][$i]['flag'] .= $msg->Draft ? $msg->Draft : '';	
+					$return['msgs'][$i]['flag'] .= $msg->Answered ? $msg->Answered : '';	
+					$return['msgs'][$i]['flag'] .= $msg->Deleted ? $msg->Deleted : '';	
+					$return['msgs'][$i]['flag'] .= ( preg_match('/((Content-Disposition:(.)*([\r\n\s]*filename))|(Content-Type:(.)*([\r\n\s]*name)))/i', $mimeBody) ) ? 'T': '';
+
+					$header = imap_fetchheader( $imap, $v , FT_UID ); // Necessario para recuperar se a mensagem é importante ou não.
+					$importante = array();
+				
+					if($msg->Flagged != 'F')
+						$return['msgs'][$i]['flag'] .= ( preg_match('/importance *: *(.*)\r/i', $header , $importante) === 0 ) ? '' : 'F';
+					else
+						$return['msgs'][$i]['flag'] .= $msg->Flagged ? $msg->Flagged : '';	
+					
+					$return['msgs'][$i]['udate'] = gmdate("d/m/Y",$msg->udate + $this->functions->CalculateDateOffset()); 
+					$return['msgs'][$i]['udatecomp'] = substr ($return['msgs'][$i]['udate'], -4) ."-". substr ($return['msgs'][$i]['udate'], 3, 2) ."-". substr ($return['msgs'][$i]['udate'], 0, 2);
+					$return['msgs'][$i]['date'] =   $msg->udate;
+					$return['msgs'][$i]['size'] =  $msg->Size;
+					$return['msgs'][$i]['boxname'] = $folder;
+					$return['msgs'][$i]['uid'] = $v;
+					$i++;
+				} 	
+			}
+		}
+		else
 		foreach ($params['folder'] as $folder) 
 		{
@@ -5072,5 +5502,5 @@
 			case 3 : $sA = 'subject'; break;
 			case 6 : $sA = 'size'; break;
-	} 
+		} 
 	
 			
Index: sandbox/expresso-solr/expressoMail1_2/js/abas.js
===================================================================
--- sandbox/expresso-solr/expressoMail1_2/js/abas.js	(revision 7520)
+++ sandbox/expresso-solr/expressoMail1_2/js/abas.js	(revision 8056)
@@ -225,4 +225,5 @@
 			openTab.imapBox[ID] = current_folder;
 	}
+	ID = $.trim(ID);
 	td = document.createElement("TD");
 	td.id="border_id_" + ID;
Index: sandbox/expresso-solr/expressoMail1_2/js/search.js
===================================================================
--- sandbox/expresso-solr/expressoMail1_2/js/search.js	(revision 7561)
+++ sandbox/expresso-solr/expressoMail1_2/js/search.js	(revision 8056)
@@ -68,5 +68,6 @@
 				"Search_the_messages_in_these_folders" : get_lang('Search the messages in these folders'),
 				"In_all_the_folders"		: get_lang('In all the folders'),
-				"From_value" : (data != "undefined" ? data : "")
+				"From_value" : (data != "undefined" ? data : ""),
+				"Folders" : $.merge(cp_tree1,cp_tree2), 
 			}
 				
@@ -76,9 +77,9 @@
 			this.modal = $(div).dialog(
 			{
-				resizable	: false,
+				resizable	: true,
 				title		: get_lang("Search Email"),
 				position	: 'center',
-				width		: 795,
 				height		: 450,
+				width		: 400,
 				modal		: true,
 				buttons		: [
@@ -107,6 +108,6 @@
 				beforeClose	: function()
 				{ 
-					$("#sel_search_nm_box1")[0].parentNode.removeChild($("#sel_search_nm_box1")[0]);
-					$("#divFoldersSearch")[0].parentNode.removeChild($("#divFoldersSearch")[0]);
+					//$("#sel_search_nm_box1")[0].parentNode.removeChild($("#sel_search_nm_box1")[0]);
+					//$("#divFoldersSearch")[0].parentNode.removeChild($("#divFoldersSearch")[0]);
 					//$(this).dialog("destroy");
 					$('fieldset', div).remove();
@@ -130,6 +131,18 @@
 	
 			// Cria as caixas postais;
-			this.foldersTree();
-			
+			//this.foldersTree();
+
+			$(".search-all-folders").change(function(){
+				$(".pickList").toggle("slow");
+			});
+
+			$("#flagged").pickList({
+		        sourceListLabel:    "Itens disponíveis",
+		        targetListLabel:    "Itens selecionados"
+		    });
+
+			//$(".pickList_controlsContainer button").button().addClass("small");
+
+		    $(".pickList").hide();
 			var dates = $("#since_date, #before_date").datepicker({
 				onSelect: function( selectedDate ) {
@@ -1448,5 +1461,5 @@
 
         }
-
+        /*
         if(trim(Element("flagged").options[Element("flagged").selectedIndex].value) != "")
         {
@@ -1494,5 +1507,5 @@
             }
         }
-
+		*/
 		if(fields == "##")
 		{
@@ -1520,56 +1533,11 @@
 		{
 			var nm_box = new Array;
-			var sel_combo = Element("sel_search_nm_box1");
-			
-			if( sel_combo.options.length <= 0)
-			{
+			var folders_select = $("#flagged").find("option:checked");
+			if(folders_select.length == 0){
 				alert(get_lang("Define the boxes to search!"));
 				return false;
-			}
-
-			for(var i=0; i < sel_combo.options.length; i++)
-			{
-				sel_combo.options[i].selected = true;
-			}
-			
-			var get_children = function(folder, arr_folder){
-				for(var y = 0; y < folder.children.length; y++){
-					if(folder.children[y]){
-						arr_folder[arr_folder.length] = folder.children[y].id;
-						if (folder.children[y].children.length > 0)
-							arr_folder = get_children(folder.children[y], arr_folder);
-						
-					}
-				}
-				return arr_folder;
-			}
-			
-			for( var i=0; i < sel_combo.options.length; i++ )
-			{
-				if( sel_combo.options[i].selected == true )
-				{
-					var arr_folders = new Array();
-					if(!proxy_mensagens.is_local_folder(sel_combo.options[i].value)){
-						nm_box[nm_box.length] = sel_combo.options[i].value + fields;
-						
-						for (x in cp_tree1){
-							if(cp_tree1[x].id == sel_combo.options[i].value){
-								arr_folders = get_children(cp_tree1[x], arr_folders);
-								for (index in arr_folders){
-									nm_box[nm_box.length] = arr_folders[index] + fields;
-								}
-							}
-						}
-						for (x in cp_tree2){
-							if(cp_tree2[x].id == sel_combo.options[i].value){
-								arr_folders = get_children(cp_tree2[x], arr_folders);
-								for (index in arr_folders){
-									nm_box[nm_box.length] = arr_folders[index] + fields;
-								}
-							}
-						}
-						
-					}else
-						local_folders.push(sel_combo.options[i].value.substr(6));
+			}else{
+				for(var i=0; i < folders_select.length; i++){
+					nm_box[nm_box.length] = $(folders_select[i]).val() + fields;
 				}
 			}
@@ -1578,4 +1546,5 @@
         var handler = function( data )
         {
+        	data = jQuery.parseJSON(data.substr(0, data.length-2));
         	var allMsg 	= [3];
 			var count  	= ( data['num_msgs'] ) ?  data['num_msgs'] : "0";
@@ -1892,2 +1861,7 @@
 var EsearchE = new searchE();
 var EsearchE = new searchE();
+
+// Configuração da tela da Ajuda
+function info(){
+	alert("Preencha os Campos para realizar o filtro, o campo das pastas caso não seja alterado realizará a pesquisa em todas as pastas.");
+}
